﻿Class CRingGroupDetails

    Public m_sGroupName As String
    Public m_sUserName As String

    Public m_nProcessMode As Integer
    Public m_nProcessType As Integer
    Public m_nPriority As Integer

    Dim m_objRingGroupUserList As cRingGroupUserList


    Public Sub New()

        m_nProcessMode = -1
        m_nProcessType = -1
        m_objRingGroupUserList = New cRingGroupUserList()

    End Sub

    Public Function AddRingGroupAgent(ByVal sUserName As String) As Boolean

        Return m_objRingGroupUserList.AddAgent(sUserName)

    End Function

    Public Sub RemoveRingGroupAgent(ByVal sUserName As String)

        m_objRingGroupUserList.RemoveAgent(sUserName)

    End Sub

    Public Function GetRingGroupAgentList(ByRef objListUserName As List(Of String)) As Boolean

        For index As Integer = 0 To m_objRingGroupUserList.GetCount() - 1
            objListUserName.Add(m_objRingGroupUserList.GetRingGroupAgentAt(index))
        Next

        Return True

    End Function

    Public Function GetRingGroupAgentCount() As Integer

        Return m_objRingGroupUserList.GetCount()

    End Function

    Public Function GetRingGroupAgentAt(ByVal nIndex As Integer) As String

        Return m_objRingGroupUserList.GetRingGroupAgentAt(nIndex)

    End Function

    Public Sub DeleteAgentAll()

        m_objRingGroupUserList.DeleteAgentAll()

    End Sub

End Class

'//////////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////////

Public Class cRingGroupList

    Dim m_objRingGroupList As New Dictionary(Of String, CRingGroupDetails)

    Public Sub New()

    End Sub

    Public Function AddRingGroup(ByVal sGroupName As String) As Boolean

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)
        If (Not objDetails Is Nothing) Then Return True

        objDetails = New CRingGroupDetails()

        objDetails.m_sGroupName = sGroupName
        m_objRingGroupList.Add(sGroupName, objDetails)

        Return True

    End Function

    Public Sub RemoveRingGroup(ByVal sGroupName As String)

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)

        If (objDetails Is Nothing) Then Return

        m_objRingGroupList.Remove(sGroupName)

    End Sub

    Public Function GetRingGroupDetails(ByVal sGroupName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer, ByRef objListUserName As List(Of String)) As Boolean

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)

        If (objDetails Is Nothing) Then Return False

        nProcessMode = objDetails.m_nProcessMode
        nProcessType = objDetails.m_nProcessType

        Return objDetails.GetRingGroupAgentList(objListUserName)

    End Function

    Public Sub SetRingGroupProcessMode(ByVal sGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer)

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return

        objDetails.m_nProcessMode = nProcessMode
        objDetails.m_nProcessType = nProcessType

    End Sub

    Public Overloads Function SetRingGroupAgentPriority(ByVal sGroupName As String, ByVal sUserName As String, ByVal nPriority As Integer) As Boolean

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)

        If (objDetails Is Nothing) Then Return False

        objDetails.m_sGroupName = sGroupName
        objDetails.m_sUserName = sUserName
        objDetails.m_nPriority = nPriority

        Return True

    End Function

    Public Function AddRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String) As Boolean

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return False

        Return objDetails.AddRingGroupAgent(sUserName)

    End Function

    Public Sub RemoveRingGroupAgent(ByVal sGroupName As String, ByVal sUserName As String)

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return

        objDetails.RemoveRingGroupAgent(sUserName)

    End Sub

    Public Function GetRingGroupList(ByRef sListRingGroupName As List(Of String))

        Dim objDetails As CRingGroupDetails = Nothing

        For Each sGroupName As KeyValuePair(Of String, CRingGroupDetails) In m_objRingGroupList

            objDetails = sGroupName.Value
            sListRingGroupName.Add(objDetails.m_sGroupName)

        Next

        Return True

    End Function

    Public Function GetRingGroupAgentCount(ByVal sGroupName As String) As Integer

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return 0

        Return objDetails.GetRingGroupAgentCount()

    End Function

    Public Function GetRingGroupAgentAt(ByVal sGroupName As String, ByVal nIndex As Integer) As String

        Dim objDetails As CRingGroupDetails = Nothing

        m_objRingGroupList.TryGetValue(sGroupName, objDetails)
        If (objDetails Is Nothing) Then Return ""

        Return objDetails.GetRingGroupAgentAt(nIndex)

    End Function

    Public Sub DeleteRingGroupAll()

        For Each objRingGroupDetails As CRingGroupDetails In m_objRingGroupList.Values
            objRingGroupDetails.DeleteAgentAll()
        Next

        m_objRingGroupList.Clear()

    End Sub


End Class
