#include "StdAfx.h"
#include "StoreRingGroup.h"

#define SUB_KEY_BUFFER_SIZE	2000

#define ROOT_PATH	"RingGroups\\"


CStoreRingGroup::CStoreRingGroup(void)
{
     
}

CStoreRingGroup::~CStoreRingGroup(void)
{
	
}

 BOOL CStoreRingGroup::AddRingGroup(LPCTSTR sRingGroupName)
 {
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sRingGroupName);

    CStoreRegistry::SetTEXT(sKeyPath, "RingGroupName", sRingGroupName);
	return TRUE;
 }

 BOOL CStoreRingGroup::RemoveRingGroup(LPCTSTR sRingGroupName)
 {
	 CString sKeyPath;
	 sKeyPath.Format("%s%s", ROOT_PATH, sRingGroupName);

	 CStoreRegistry::DeleteSubKey(sKeyPath);
		
	return TRUE;
	
 }

BOOL CStoreRingGroup::GetRingGroupList(CStringList* pListRingGroup)
 {
	 CString sKeyPath;
	sKeyPath = ROOT_PATH;

    CStoreRegistry::EnumSubKeys(sKeyPath, pListRingGroup);
	return TRUE;
 }

////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

BOOL CStoreRingGroup::AddRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sUserName)
{
	 CString sKeyPath;
	 sKeyPath.Format("%s%s%s%s", ROOT_PATH, sRingGroupName, "\\", sUserName);

	 CStoreRegistry::SetTEXT(sKeyPath, "UserName", sUserName);	
	 return TRUE;
}

BOOL CStoreRingGroup::RemoveRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sUserName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sRingGroupName, "\\", sUserName);

	CStoreRegistry::DeleteSubKey(sKeyPath);
	return TRUE;
}

BOOL CStoreRingGroup::GetRingGroupAgentList(LPCTSTR sRingGroupName, CStringList* pListRingGroup)
{
	 CString sKeyPath;
	 sKeyPath.Format("%s%s", ROOT_PATH, sRingGroupName);

    CStoreRegistry::EnumSubKeys(sKeyPath, pListRingGroup);
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

BOOL CStoreRingGroup::SetRingGroupProcessMode(LPCTSTR sRingGroupName, int nProcessMode, int nProcessType)
{
	 CString sKeyPath;
	 sKeyPath.Format("%s%s", ROOT_PATH, sRingGroupName);

    CStoreRegistry::SetINT(sKeyPath, "ProcessMode", nProcessMode);
    CStoreRegistry::SetINT(sKeyPath, "ProcessType", nProcessType);
		
    return TRUE;
}

BOOL CStoreRingGroup::GetRingGroupProcessMode(LPCTSTR sRingGroupName, int& nProcessMode, int& nProcessType)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sRingGroupName);

	CStoreRegistry::GetINT(sKeyPath, "ProcessMode", nProcessMode);
	CStoreRegistry::GetINT(sKeyPath, "ProcessType", nProcessType);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL CStoreRingGroup::SetRingGroupAgentPriority(LPCTSTR sRingGroupName, LPCTSTR sAgentName, int nPriority)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sRingGroupName, "\\", sAgentName);

	CStoreRegistry::SetINT(sKeyPath, "Priority", nPriority);
	return TRUE;
}

BOOL CStoreRingGroup::GetRingGroupAgentPriority(LPCTSTR sRingGroupName, CString& sAgentName, int& nPriority)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sRingGroupName, "\\", sAgentName);

	CStoreRegistry::GetINT(sKeyPath, "Priority", nPriority);
	return TRUE;
}

BOOL CStoreRingGroup::RemoveRingGroupAgentPriority(LPCTSTR sRingGroupName, LPCTSTR sAgentName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", ROOT_PATH, sRingGroupName, "\\", sAgentName);

	CStoreRegistry::DeleteSubKey(sKeyPath);
	return TRUE;
}

BOOL CStoreRingGroup::IsDataStored()
{
	return CStoreRegistry::IsKeyExist(ROOT_PATH);
}