﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cRingGroupDetails
    {
        public string m_sRingGroupName;
        public string m_sUserName;

	    public int m_nProcessMode;
	    public int m_nProcessType;
        public int m_nPriority;

        cRingGroupUserList m_objRingGroupUserList = null;

        public cRingGroupDetails()
        {
             m_objRingGroupUserList = new cRingGroupUserList();
             m_nProcessMode = -1;
             m_nProcessType = -1;
        }
        ~cRingGroupDetails()
        {
            m_objRingGroupUserList.RemoveAll();
        }

        public bool AddRingGroupAgent(string sUserName)
        {
            return m_objRingGroupUserList.AddAgent(sUserName);
        }

        public void RemoveRingGroupAgent(string sUserName)
        { 
            m_objRingGroupUserList.RemoveAgent(sUserName);
        }

        public bool GetRingGroupAgentList(ref List<string> objListUserName)
        {
            return m_objRingGroupUserList.GetRingGroupAgentList(ref objListUserName);
        }

        public int GetRingGroupAgentCount()
        {
            return m_objRingGroupUserList.GetCount();
        }

        public String GetRingGroupAgentAt(int nIndex)
        {
            return m_objRingGroupUserList.GetRingGroupAgentAt(nIndex);
        }
    }

    
    ///////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////
    
    class cRingGroupList
    {
        Dictionary<string, cRingGroupDetails> m_objRingGroupList = new Dictionary<string, cRingGroupDetails>();

        
        public bool AddRingGroup(string sRingGroupName)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
            {
                objDetails = new cRingGroupDetails();
                m_objRingGroupList.Add(sRingGroupName, objDetails);
            }

            objDetails.m_sRingGroupName = sRingGroupName;

            return true;
        }

	    public void RemoveRingGroup(string sRingGroupName)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return;

            m_objRingGroupList.Remove(sRingGroupName);
        }

        public void DeleteRingGroupAll()
        {
            m_objRingGroupList.Clear();
        }

        public bool GetRingGroupDetails(string sRingGroupName, ref int nProcessMode, ref  int nProcessType, ref List<string> objListUserName)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return false;

            nProcessMode = objDetails.m_nProcessMode;
            nProcessType = objDetails.m_nProcessType;

            return objDetails.GetRingGroupAgentList(ref objListUserName);
        }

        public void SetRingGroupProcessMode(string sRingGroupName, int nProcessMode, int nProcessType)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return;

            objDetails.m_nProcessMode = nProcessMode;
            objDetails.m_nProcessType = nProcessType;
        }

        public bool SetRingGroupAgentPriority(string sRingGroupName, string sUserName, int nPriority)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return false;

            objDetails.m_sRingGroupName = sRingGroupName;
            objDetails.m_sUserName = sUserName;
            objDetails.m_nPriority = nPriority;

            return true;
        }

	    public bool AddRingGroupAgent(string sRingGroupName, string sUserName)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return false;

            return objDetails.AddRingGroupAgent(sUserName);
        }

	    public void RemoveRingGroupAgent(string sRingGroupName, string sUserName)
        {
            cRingGroupDetails objDetails = null;
            
            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return;

            objDetails.RemoveRingGroupAgent(sRingGroupName);
        }

	    public bool GetRingGroupList(ref List<string> objListGroupName)
        {
            cRingGroupDetails objDetails = null;

            foreach (KeyValuePair<string, cRingGroupDetails> sRingGroupName in m_objRingGroupList)
            {
                objDetails = sRingGroupName.Value;
                objListGroupName.Add(objDetails.m_sRingGroupName);
            }

            return true;
        }

        public int GetRingGroupAgentCount(string sRingGroupName)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);
            if(objDetails == null) return 0;
            
            return objDetails.GetRingGroupAgentCount();
        }

        public string GetRingGroupAgentAt(string sRingGroupName, int nIndex)
        {
            cRingGroupDetails objDetails = null;

            m_objRingGroupList.TryGetValue(sRingGroupName, out objDetails);

            if(objDetails == null)
                return "";

            return objDetails.GetRingGroupAgentAt(nIndex);
        }
    }
}
