﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreCallPickUp : cStoreRegistry
    {
        const string CALL_PICKUP_GROUP_ROOT_PATH = "CallPickUpGroups\\";

        public cStoreCallPickUp()
        {
        }

        ~cStoreCallPickUp()
        {
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////

        public bool AddCallPickUpGroup(string sCallPickUpGroupName)
        {
            if(sCallPickUpGroupName.Length == 0)
                return false;

            string sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName;
            return base.SetTEXT(sKeyPath, "CallPickUpGroupName", sCallPickUpGroupName);
        }

        public bool RemoveCallPickUpGroup(string sCallPickUpGroupName)
        {
            if(sCallPickUpGroupName.Length == 0)
                return false;

            string sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName;
            return base.DeleteSubKey(sKeyPath);
        }

        public bool GetCallPickUpGroupNameAll(ref List<string> objListPickUpGroup)
        {
            objListPickUpGroup.Clear();

            string sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH;
            return base.EnumSubKeys(sKeyPath, ref objListPickUpGroup);
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////////////

        public bool AddCallPickUpGroupMember(string sCallPickUpGroupName, string sUserName)
        {
            if(sCallPickUpGroupName.Length == 0 || sUserName.Length == 0)
                return false;

            string sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName + "\\" + sUserName;
            return base.SetTEXT(sKeyPath, "UserName", sUserName);
        }

        public bool RemoveCallPickUpGroupMember(string sCallPickUpGroupName, string sUserName)
        {
            if(sCallPickUpGroupName.Length == 0 || sUserName.Length == 0)
                return false;

            string sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName + "\\" + sUserName;
            return base.DeleteSubKey(sKeyPath);
        }

        public bool GetPickUpMemberNameAll(string sCallPickUpGroupName, ref List<string> objListPickUpGroupMemberName)
        {
            objListPickUpGroupMemberName.Clear();

            if(sCallPickUpGroupName.Length == 0)
                return false;
            
            string sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName;
            return base.EnumSubKeys(sKeyPath, ref objListPickUpGroupMemberName);
        }

        public bool IsDataStored()
        {
            return base.IsKeyExist(CALL_PICKUP_GROUP_ROOT_PATH);
        }
    }
}
