unit VaxLine;

interface

uses
    System.Classes,
    VaxServerExCOM;

type TVaxLine = class

    private

    m_sLineName, m_sDisplayName, m_sUserName, m_sAuthUser, m_sAuthPwd: String;
    m_sDomainRealm, m_sProxySIP, m_sCodecList, m_sToPeerName, m_sRoomName: String;
    m_bRegister, m_bBlocked: Boolean;

    m_nToPeerType: Integer;

    public

        procedure OnLineRegisterTrying(sLineName: String);
        procedure OnLineRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String);
        procedure OnLineRegisterSuccess(sLineName: String);

        procedure OnLineUnRegisterTrying(sLineName: String);
        procedure OnLineUnRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String);
        procedure OnLineUnRegisterSuccess(sLineName: String);

    public

        constructor Create();

        function SetData(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList: String; bRegister: boolean; nToPeerType: Integer; sToPeerName: String; bBlocked: boolean; sRoomName: String): boolean;
        function GetData(sLineName: String; var sDiaplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList: String; var bRegister: boolean; var nToPeerType: Integer; var sToPeerName: String; var bBlocked: boolean; var sRoomName: String): boolean;

        function IsRegister(): boolean;
        procedure SetRegister(bResgiter: Boolean);


end;

implementation



        //////////////////////////////////////////////////////////////////////////
        ///     Functions
        //////////////////////////////////////////////////////////////////////////

        constructor TVaxLine.Create();
        begin

        end;

        function TVaxLine.SetData(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList: String; bRegister: boolean; nToPeerType: Integer; sToPeerName: String; bBlocked: boolean; sRoomName: String): boolean;
        begin
            m_sLineName := sLineName;
            m_sDisplayName := sDisplayName;
            m_sUserName := sUserName;

            m_sAuthUser := sAuthUser;
            m_sAuthPwd := sAuthPwd;

            m_sDomainRealm := sDomainRealm;
            m_sProxySIP := sProxySIP;
            m_sCodecList := sCodecList;

            m_bRegister := bRegister;
            m_nToPeerType := nToPeerType;
            m_sToPeerName := sToPeerName;

            m_bBlocked := bBlocked;
            m_sRoomName := sRoomName;

            Result := True;
        end;

        function TVaxLine.GetData(sLineName: String; var sDiaplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList: String; var bRegister: boolean; var nToPeerType: Integer; var sToPeerName: String; var bBlocked: boolean; var sRoomName: String): boolean;
        Begin
            sDiaplayName := m_sDisplayName;
            sUserName := m_sUserName;
            sAuthUser := m_sAuthUser;
            sAuthPwd := m_sAuthPwd;
            sDomainRealm := m_sDomainRealm;
            sProxySIP := m_sProxySIP;
            sCodecList := m_sCodecList;

            bRegister := m_bRegister;
            nToPeerType := m_nToPeerType;
            sToPeerName := m_sToPeerName;
            bBlocked := m_bBlocked;

            sRoomName := m_sRoomName;
            Result := True;
        end;

        function TVaxLine.IsRegister(): boolean;
        begin
            Result := m_bRegister;
        end;

        procedure TVaxLine.SetRegister(bResgiter: Boolean);
        begin
            m_bRegister := bResgiter;
        end;


        //////////////////////////////////////////////////////////////////////////
        ///     Events
        //////////////////////////////////////////////////////////////////////////

        procedure TVaxLine.OnLineRegisterTrying(sLineName: String);
        var
         sStatus: String;
        begin
	          sStatus := sLineName + ': Trying to register';
            TVaxServerExCOM.mVaxExCOM.OnStatusLog(sStatus);
        end;

        procedure TVaxLine.OnLineRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String);
        var
         sStatus: String;
        begin
	          sStatus := sLineName + ': Failed to register (' + sReasonPhrase + ')';
            TVaxServerExCOM.mVaxExCOM.OnStatusLog(sStatus);
        end;

        procedure TVaxLine.OnLineRegisterSuccess(sLineName: String);
        var
         sStatus: String;
        begin
	          sStatus := sLineName + ': Registered successfully';
            TVaxServerExCOM.mVaxExCOM.OnStatusLog(sStatus);
        end;

        procedure TVaxLine.OnLineUnRegisterTrying(sLineName: String);
        begin

        end;

        procedure TVaxLine.OnLineUnRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String);
        begin
          //
        end;

        procedure TVaxLine.OnLineUnRegisterSuccess(sLineName: String);
        begin
          //
        end;
end.
