﻿

Imports ServerSIP.VBNetSIPServerSample

Public Class DirectProxyForm

    Private m_objVaxTeleSIP As cVaxServerSIP

    Public Sub New(ByRef objVaxTeleSIP As cVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP

    End Sub


    Private Sub BtnAddProxy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddLine.Click

        If (AddProxyChecks() = False) Then Return

        Dim sProxyName As String = ""

        If (ComboProxy.FindStringExact(ComboProxy.Text, 0) <> -1) Then
            If (MessageBox.Show("Direct-Proxy already exists, do you want to continue?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = DialogResult.No) Then
                Return
            End If
        End If

        Dim objCodec As cCodec = New cCodec()
        Dim sCodec As String = ""
        Dim nCount As Integer = 0

        For nCount = 0 To ListBoxEnableCodec.Items.Count - 1
            sCodec += objCodec.GetCodecNo(ListBoxEnableCodec.Items.Item(nCount).ToString())     ' gets the enabled codecs
        Next

        '/////////////////////////////////////////////////////////////

        Dim nToPeerType As Integer = -1
        Dim sToPeerName As String = "", sRoomName As String = ""
        Dim bRejected As Boolean = False

        If (RadioRejectCall.Checked) Then
            bRejected = True

        ElseIf (RadioConnectToUser.Checked) Then
            nToPeerType = cVaxServerCOM.VAX_PEER_TYPE_USER
            sToPeerName = ComboConnectToUser.Text.Trim().ToString()

        ElseIf (RadioPutInConf.Checked) Then
            sRoomName = ComboPutInConf.Text.Trim().ToString()
        End If

        '/////////////////////////////////////////////////////////////

        If (ComboProxy.Items.Contains(ComboProxy.Text)) Then
            m_objVaxTeleSIP.RemoveDirectProxySIP(ComboProxy.Text.Trim())
        End If

        If (m_objVaxTeleSIP.AddDirectProxySIP(ComboProxy.Text, EditAuthUser.Text, EditPassword.Text, EditDomainRealm.Text, EditProxySIP.Text, Convert.ToInt32(EditProxyPort.Text), sCodec, nToPeerType, sToPeerName, bRejected, sRoomName) = False) Then
            MessageBox.Show("Direct-Proxy could not be created or Please start the server first.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If (Not ComboProxy.Items.Contains(ComboProxy.Text)) Then
            ComboProxy.Items.Add(ComboProxy.Text)
        End If

        MessageBox.Show("Direct-Proxy added/updated successfully.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnRemoveProxy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveLine.Click

        If (ComboProxy.Text.Length <= 0) Then
            MessageBox.Show("Please enter proxy name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        Dim nIndex As Integer = ComboProxy.FindStringExact(ComboProxy.Text)
        If (nIndex = -1) Then Return

        ComboProxy.Items.RemoveAt(nIndex)
        m_objVaxTeleSIP.RemoveDirectProxySIP(ComboProxy.Text)

        ClearDlgContent()

        If (ComboProxy.Items.Count > 0) Then
            ComboProxy.SelectedIndex = 0
        End If

        ShowProxyDetails()

        MessageBox.Show("Direct-Proxy removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnClearProxyDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLineDlg.Click
        ClearDlgContent()
    End Sub

    Private Sub BtnDisableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisableCodec.Click

        If (ListBoxEnableCodec.Items.Count <= 0) Then Return

        ListBoxDisableCodec.Items.Add(ListBoxEnableCodec.SelectedItem.ToString())
        ListBoxEnableCodec.Items.Remove(ListBoxEnableCodec.SelectedItem)

    End Sub

    Private Sub BtnEnableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEnableCodec.Click

        If (ListBoxDisableCodec.Items.Count <= 0) Then Return

        ListBoxEnableCodec.Items.Add(ListBoxDisableCodec.SelectedItem.ToString())
        ListBoxDisableCodec.Items.Remove(ListBoxDisableCodec.SelectedItem)

    End Sub

    Private Sub AddDirectProxyForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadCodecs()

    End Sub

    Private Sub ComboProxy_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboProxy.SelectedIndexChanged

        ShowProxyDetails()

    End Sub

    Public Sub ClearDlgContent()

        Dim nProxyPort As Integer = 5060

        ComboProxy.Text = ""

        EditAuthUser.Text = ""
        EditPassword.Text = ""
        EditDomainRealm.Text = ""
        EditProxySIP.Text = ""
        EditProxyPort.Text = nProxyPort.ToString()

        If (ComboConnectToUser.Items.Count > 0) Then
            ComboConnectToUser.SelectedIndex = 0
        End If

        If (ComboPutInConf.Items.Count > 0) Then
            ComboPutInConf.SelectedIndex = 0
        End If

        RadioRejectCall.Checked = True

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        ListBoxEnableCodec.Items.Add(cCodec.G711U_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G711A_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.ILBC_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G610_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G729_TEXT)

    End Sub

    Private Sub UpdateDlgContent(ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sRealm As String, ByVal sProxySIP As String, ByVal sCodecList As String, ByVal lProxyPort As Long, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String)

        EditAuthUser.Text = sAuthUser
        EditPassword.Text = sAuthPwd
        EditDomainRealm.Text = sRealm
        EditProxySIP.Text = sProxySIP
        EditProxyPort.Text = lProxyPort.ToString()

        UpdateIncomingCallSection(nToPeerType, sToPeerName, bRejected, sRoomName)

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        Dim objCodec As cCodec = New cCodec()
        Dim nCount = 0
        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxDisableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

        Dim sCodecName As String
        nCount = 0
        For nCount = 0 To sCodecList.Length - 1
            sCodecName = objCodec.GetCodecName(sCodecList(nCount).ToString())
            ListBoxEnableCodec.Items.Add(sCodecName)
            ListBoxDisableCodec.Items.Remove(sCodecName)
        Next

    End Sub

    Private Sub UpdateIncomingCallSection(ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String)

        If (bRejected = True) Then
            RadioRejectCall.Checked = True
        End If

        If (nToPeerType = cVaxServerCOM.VAX_PEER_TYPE_USER) Then

            Dim nIndex = ComboConnectToUser.FindStringExact(sToPeerName)
            If (nIndex = -1) Then
                RadioRejectCall.Checked = True
                Return
            End If

            If (ComboConnectToUser.Items.Count > 0) Then
                ComboConnectToUser.SelectedIndex = nIndex
                RadioConnectToUser.Checked = True
            End If
        End If

        If (sRoomName.Length <> 0) Then

            Dim nIndex As Integer = ComboPutInConf.FindStringExact(sRoomName)
            If (nIndex = -1) Then
                RadioRejectCall.Checked = True
                Return
            End If

            If (ComboPutInConf.Items.Count > 0) Then
                ComboPutInConf.SelectedIndex = nIndex
                RadioPutInConf.Checked = True
            End If

        End If

    End Sub

    Private Sub AddUsers()

        ComboConnectToUser.Items.Clear()

        Dim objUserList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetUserNameAll(objUserList)

        If (objUserList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objUserList.Count - 1
            ComboConnectToUser.Items.Add(objUserList.Item(nIndex))
        Next

        If (ComboConnectToUser.Items.Count > 0) Then
            ComboConnectToUser.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddRooms()

        ComboPutInConf.Items.Clear()

        Dim objRoomList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetRoomAll(objRoomList)

        If (objRoomList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objRoomList.Count - 1
            ComboPutInConf.Items.Add(objRoomList.Item(nIndex))
        Next

        If (ComboPutInConf.Items.Count > 0) Then
            ComboPutInConf.SelectedIndex = 0
        End If

    End Sub

    Private Sub AddDirectProxies()

        ComboProxy.Items.Clear()

        Dim objProxyList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetDirectProxyAll(objProxyList)

        If (objProxyList.Count <= 0) Then
            Return
        End If

        For nIndex = 0 To objProxyList.Count - 1
            ComboProxy.Items.Add(objProxyList.Item(nIndex))
        Next

        If (ComboProxy.Items.Count > 0) Then
            ComboProxy.SelectedIndex = 0
        End If

    End Sub

    Private Sub LoadCodecs()

        Dim objCodec As cCodec = New cCodec()
        Dim nCount = 0

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxEnableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

    End Sub

    Private Function AddProxyChecks() As Boolean

        If ComboProxy.Text.Length = 0 Then
            MessageBox.Show("Please enter Line Name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If (ListBoxEnableCodec.Items.Count <= 0) Then
            MessageBox.Show("Please select a codec.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Return True

    End Function

    Public Sub OnSetActive()

        AddUsers()
        AddRooms()

        AddDirectProxies()
        ShowProxyDetails()

    End Sub

    Private Sub ShowProxyDetails()

        Dim sProxyName As String = ComboProxy.Text
        If (sProxyName.Length = 0) Then Return

        Dim sAuthUser As String = "", sAuthPwd As String = ""
        Dim sDomainRealm As String = "", sProxySIP As String = ""
        Dim sCodecList As String = "", sRoomName As String = "", sToPeerName As String = ""

        Dim bRejected As Boolean = False

        Dim nProxyPort As Integer = -1
        Dim nToPeerType As Integer = -1

        m_objVaxTeleSIP.GetDirectProxyDetails(sProxyName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bRejected, sRoomName)
        UpdateDlgContent(sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, nProxyPort, nToPeerType, sToPeerName, bRejected, sRoomName)

    End Sub

End Class

