#pragma once
#include "VaxServerSIP.h"

#include "Registry.h"

class CStatusLogDlg;
class CErrorLogDlg;

class CVaxServerExSIP : public CVaxServerSIP
{

public:
	CStatusLogDlg* m_pStatusLogDlg;
	CErrorLogDlg* m_pErrorLogDlg;

public:
	CVaxServerExSIP();
	~CVaxServerExSIP();

public:

	BOOL StartServer(LPCTSTR sDomainRealm, LPCTSTR sListenIP, int nListenPort);
	void StopServer();

	int GetCallCount();
	int GetUserCount();

	DWORD GetUsageCPU();
	DWORD GetAvailMEM();

public:

	void OnStatusLog(LPCTSTR sStatus);
	void OnErrorLog(LPCTSTR sErrorMsg);

	BOOL AddUserToLineRoute(CString sUserName, LPCTSTR sUserPrefix, int nConnectType, LPCTSTR sConnectName, LPCTSTR sDialPrefix);
	BOOL AddUserToDirectProxyRoute(CString sUserName, LPCTSTR sUserPrefix, int nConnectType, LPCTSTR sConnectName, LPCTSTR sDialPrefix);

	BOOL AddLineToUserRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName);
	BOOL AddLineToLineRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName);
	BOOL AddLineToDirectProxyRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName);
	BOOL AddLineToQueueRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName);
	BOOL AddLineRejectRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName);

	BOOL AddDirectProxyToUserRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo);
	BOOL AddDirectProxyToLineRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo);
	BOOL AddDirectProxyToDirectProxyRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo);
	BOOL AddDirectProxyToQueueRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo);
	BOOL AddDirectProxyRejectRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo);

public:

	// UserLogin Virtual Functions

	void OnUnRegisterUser(LPCTSTR sUserLogin);
	void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sFromIP, LONG lFromPort);
	void OnRegisterUserSuccess(LPCTSTR sUserLogin);
	void OnRegisterUserFail(LPCTSTR sUserLogin);

	// Line Virtual Functions

	void OnLineRegisterTrying(LPCTSTR sLineName);
	void OnLineRegisterFail(LPCTSTR sLineName, long lStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(LPCTSTR sLineName);
	void OnLineUnRegisterTrying(LPCTSTR sLineName);
	void OnLineUnRegisterFail(LPCTSTR sLineName);
	void OnLineUnRegisterSuccess(LPCTSTR sLineName);


};

	//void ShowUsers(CStringList* pUserList);
	//BOOL UserInfo(LPCTSTR sLogin, CString& sPassword, CString& sCodecList, CString& sDialPrefix, CString& sUserPrefix, CString& sConnectName, BOOL& bStealth, BOOL& bBlock);
	//BOOL AddUser(LPCTSTR sLogin, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bStealth, BOOL bBlock, LPCTSTR sDialPrefix, LPCTSTR sCallPrefix, LPCTSTR sConnectName, DWORD dwRouteType, BOOL& bUpdated);
	//BOOL RemoveUser(LPCTSTR sLogin);

	//void ShowLines(CStringList* pLineList);
	//BOOL LineInfo(LPCTSTR sLineName, CString& sCodecList, CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sOutboundProxy, BOOL& bIsRegister, DWORD& dwInCallType, CString& sInCallTo);
	//BOOL AddLine(LPCTSTR sLineName, LPCTSTR sCodecList, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sOutboundProxy, BOOL bRegister, DWORD dwInCallType, LPCTSTR sInCallTo,BOOL& bUpdated);
	//BOOL RemoveLine(LPCTSTR sLineName);

	//void ShowDirectProxies(CStringList* pProxyList);
	//BOOL DirectProxyInfo(LPCTSTR sProxyName, CString& sCodecList, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, DWORD& dwProxyPort, DWORD& dwInCallType, CString& sInCallTo);
	//BOOL AddDirectProxy(LPCTSTR sProxyName, LPCTSTR sCodecList, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, DWORD dwProxyPort, DWORD dwInCallType, LPCTSTR sInCallTo, BOOL& bUpdated);
	//BOOL RemoveDirectProxy(LPCTSTR sProxyName);

	//void ShowQueues(CStringList* pQueueList);
	//BOOL QueueInfo(LPCTSTR sQueueName, CString& sPlayWave, CString& sDigitPlayWave, CStringList* pQueueOPList, CStringList* pPressDigitList, CStringList* pPressDigitUserList);
	//BOOL AddQueue(LPCTSTR sQueueName, LPCTSTR sPlayWave, LPCTSTR sDigitPlayWave, CStringList* pQueueOPList, CStringList* pPressDigitList, CStringList* pPressDigitUserList, BOOL bEnableDTMF, BOOL& bUpdated);
	//BOOL RemoveQueue(LPCTSTR sQueueName);
	//	
	//BOOL SetStealthMusic(LPCTSTR sStealthMusic);
	//CString GetStealthMusic();
	//
	//BOOL SetHoldMusic(LPCTSTR sHoldMusic);
	//CString GetHoldMusic();

	//BOOL SetDialToneMusic(LPCTSTR sDialToneMusic);
	//CString GetDialToneMusic();

	//BOOL GetCOMM(CString& sListenIP, int& nListenPort, CString& sDomainRealm);
	//BOOL SetCOMM(LPCTSTR sListenIP, int nListenPort, LPCTSTR sDomainRealm);

	//void LoadServerData(LPCTSTR sHoldPlayWave, LPCTSTR sDialTonePlayWave, LPCTSTR sStealthPlayWave);

	//void LoadLinesToServer();
	//void LoadDirectProxiesToServer();
	//void LoadQueuesToServer();